{#eclipse_base}
{#precontent}
{|<style>
.panel.list-group > div {
    background-color: white;
    border-left: 1px solid #ddd;
    border-right: 1px solid #ddd;
}
.panel.list-group .list-group-item .badge {
    background-color: #ffd8cc;
    color: #c74922;
    border-color: #c74922;
}</style>|}
{/}
{#content} 
  <h2>Standard cache</h2>
  <table class="table">
    <caption>List of active keys in the Quarkus cache for the current application</caption>
    <thead>
      <th scope="col">ID</th>
      <th scope="col">Params</th>
      <th scope="col">Type</th>
      <th scope="col">TTL</th>
      <th scope="col">Actions</th>
    </thead>
    <tbody>
    {#for entry in cacheKeys.orEmpty}
      <tr>
        <td>{entry.key.id}</td>
        <td>{entry.key.params.toJson}</td>
        <td>{entry.key.clazz.getSimpleName}</td>
        <td>{entry.ttl or "Unknown"}</td>
        <td>
          <button class="btn" onclick="postClearRequest(this)" data-params="{entry.key.params.toJson}" data-class="{entry.key.clazz.getName}" data-key="{key}" data-id="{entry.key.id}" data-type="standard">Clear</button>
          <button class="btn" onclick="postValueRequest(this)" data-params="{entry.key.params.toJson}" data-key="{key}" data-class="{entry.key.clazz.getName}" data-id="{entry.key.id}" data-type="standard">View</button>
        </td>
      </tr>
    {/for}
    </tbody>
  </table>
  
  <h2 class="margin-top-50">Loading cache</h2>
  <table class="table margin-bottom-30">
    <caption>List of active keys in the loading cache manager for the current application</caption>
    <thead>
      <th scope="col">ID</th>
      <th scope="col">Params</th>
      <th scope="col">Type</th>
      <th scope="col">Actions</th>
    </thead>
    <tbody>
    {#for cacheKey in loadingCacheKeys.orEmpty}
      <tr>
        <td>{cacheKey.id}</td>
        <td>{cacheKey.params.toJson}</td>
        <td>{cacheKey.clazz.getSimpleName}</td>
        <td>
          <button class="btn" onclick="postClearRequest(this)" data-params="{cacheKey.params.toJson}" data-key="{key}" data-class="{cacheKey.clazz.getName}" data-id="{cacheKey.id}" data-type="loading">Clear</button>
          <button class="btn" onclick="postValueRequest(this)" data-params="{cacheKey.params.toJson}" data-key="{key}" data-class="{cacheKey.clazz.getName}" data-id="{cacheKey.id}" data-type="loading">View</button>
        </td>
      </tr>
    {/for}
    </tbody>
  </table>
{/}
{#postcontent}
{|<script>
  async function postValueRequest(ctx) {
    const k = ctx.getAttribute('data-key');
    const id = ctx.getAttribute('data-id');
    window.location = `${id}/value?` + new URLSearchParams({
        key: k,
        cache_request: btoa(buildParameterizedKeyJSON(ctx))
      });
  }

  async function postClearRequest(ctx) {
    const k = ctx.getAttribute('data-key');
    const id = ctx.getAttribute('data-id');
    doRequest(ctx, `${id}/clear?` + new URLSearchParams({
        key: k
      }), (data) => location.reload());
  }
  
  async function doRequest(ctx, url, action) {
    const id = ctx.getAttribute('data-id');
    
    // the url built for the clear request
    await fetch(url, {
      method: 'POST', 
      cache: 'no-cache',
      credentials: 'same-origin', 
      headers: {
        'Content-Type': 'application/json',
      },
      redirect: 'follow',
      body: buildParameterizedKeyJSON(ctx),
    }).then(r => {
      if (r.status === 200 ) {
        action.call(this, r);
      } else {
        alert(`Could not action cache request for key ${id}`);
      }
    });
  }
  
  function buildParameterizedKeyJSON(ctx) {
    const p = ctx.getAttribute('data-params');
    const type = ctx.getAttribute('data-type');
    const clazz = ctx.getAttribute('data-class');
    
    return JSON.stringify({ 
        params: JSON.parse(p),
        clazz: clazz,
        cache_type: type,
      });
  }

</script>|}
{/}
{/}